from tkinter import *
import tkinter.filedialog

class WhileGUI:

    def __init__(self, variablenzustand, assembler, interpreterGoto):
        # Referenzattribute zum Datenmodell
        self.variablenzustand = variablenzustand
        self.assembler = assembler
        self.interpreterGoto = interpreterGoto
        


        # Erzeugung des Fensters
        self.fenster = Tk()
        self.fenster.title("Interpreter für Komfort-Assembler und Übersetzer nach Bonsai-Assembler")
        self.fenster.geometry('745x620')
        # Farben
        blau = "#BDE2F3"
        rot = "#FFCFC9"
        gelb = "#FBD975"
        gruen = "#D5E88F"

        # Quelltext
        self.rahmenQuelltext = Frame(master=self.fenster, background=gruen)
        self.rahmenQuelltext.place(x=5, y=5, width=180, height=610)
        # Texteditor für das Programm
        self.scrollbarQuelltext = Scrollbar(master=self.rahmenQuelltext)
        self.scrollbarQuelltext.place(x=160, y=8, width=10, height=515)
        self.quelltext = Text(master=self.rahmenQuelltext, width=16, height=32, wrap=WORD, yscrollcommand=self.scrollbarQuelltext.set)
        self.scrollbarQuelltext["command"] = self.quelltext.yview
        self.quelltext.place(x=8, y=8)
        # Quelltext laden
        self.buttonQuelltextLaden = Button(master=self.rahmenQuelltext, text="Quelltext laden", command=self.Button_QuelltextLaden_Click)
        self.buttonQuelltextLaden.place(x=8, y=535, width=135, height=20)
        # Programm speichern
        self.buttonQuelltextSpeichern = Button(master=self.rahmenQuelltext, text="Quelltext speichern", command=self.Button_QuelltextSpeichern_Click)
        self.buttonQuelltextSpeichern.place(x=8, y=560, width=135, height=20)
        # Programm übernehmen
        self.buttonQuelltextUebernehmen = Button(master=self.rahmenQuelltext, text="Quelltext übernehmen", command=self.Button_Quelltext_Uebernehmen_Click)
        self.buttonQuelltextUebernehmen.place(x=8, y=585, width=135, height=20)

        

        # Ausführfenster
        # Rahmen
        self.rahmenProgramm = Frame(master=self.fenster, background=rot)
        self.rahmenProgramm.place(x=190, y=5, width=180, height=610)
        # Text-Fenster für WhileList
        self.scrollbarProgramm = Scrollbar(master=self.rahmenProgramm)
        self.scrollbarProgramm.place(x=160, y=8, width=10, height=515)
        self.textProgramm = Text(master=self.rahmenProgramm, width=16, height=32, wrap=WORD, yscrollcommand=self.scrollbarProgramm.set)
        self.scrollbarProgramm["command"] = self.textProgramm.yview
        self.textProgramm.place(x=8, y=8)
        # Button Anweisung ausführen
        self.buttonAnweisungAusfuehren = Button(master=self.rahmenProgramm, text="Anweisung ausführen", command=self.Button_AnweisungAusfuehren_Click)
        self.buttonAnweisungAusfuehren.place(x=8, y=535, width=135, height=20)
        # Button Programm ausführen
        self.buttonProgrammAusfuehren = Button(master=self.rahmenProgramm, text="Programm ausführen", command=self.Button_ProgrammAusfuehren_Click)
        self.buttonProgrammAusfuehren.place(x=8, y=560, width=135, height=20)
        # Button Programm ausführen
        self.buttonAssemblerProgrammErzeugen = Button(master=self.rahmenProgramm, text="Bonsai-Code erzeugen", command=self.Button_BonsaiCodeErzeugen_Click)
        self.buttonAssemblerProgrammErzeugen.place(x=8, y=585, width=135, height=20)
        self.goto_assembler = "goto"

        # Variablenzustand
        # Rahmen
        self.variablenZustand = Frame(master=self.fenster, background=rot)
        self.variablenZustand.place(x=375, y=5, width=180, height=610)
        # Text-Fenster für Variablenzustand
        self.scrollbarVariablenZustand = Scrollbar(master=self.variablenZustand)
        self.scrollbarVariablenZustand.place(x=160, y=8, width=10, height=515)
        self.textVariablenZustand = Text(master=self.variablenZustand, width=16, height=32, wrap=WORD, yscrollcommand=self.scrollbarVariablenZustand.set)
        self.scrollbarVariablenZustand["command"] = self.textVariablenZustand.yview
        self.textVariablenZustand.place(x=8, y=8)

        # Button initialisieren
        self.buttonInitialisieren = Button(master=self.variablenZustand, text="initialisieren", command=self.buttonInitialisierenClick)
        self.buttonInitialisieren.place(x=8, y=535, width=135, height=20)

        # Bonsai-Code
        # Rahmen
        self.bonsaiCode = Frame(master=self.fenster, background=blau)
        self.bonsaiCode.place(x=560, y=5, width=180, height=610)
        # Text-Fenster für Variablenzustand
        self.scrollbarBonsaiCode = Scrollbar(master=self.bonsaiCode)
        self.scrollbarBonsaiCode.place(x=160, y=8, width=10, height=515)
        self.textBonsaiCode = Text(master=self.bonsaiCode, width=16, height=32, wrap=WORD, yscrollcommand=self.scrollbarBonsaiCode.set)
        self.scrollbarBonsaiCode["command"] = self.textBonsaiCode.yview
        self.textBonsaiCode.place(x=8, y=8)

        # Button speichern
        self.buttonBonsaiSpeichen = Button(master=self.bonsaiCode, text="speichern", command=self.Button_BonsaiSpeichern_Click)
        self.buttonBonsaiSpeichen.place(x=8, y=535, width=135, height=20)


    def aktualisiereVariablenzustand(self):
        self.textVariablenZustand.delete('1.0', END)
        p = self.variablenzustand.variablen
        if p != None:
            for v in p:
                self.textVariablenZustand.insert(END, str(v[0]) + ' -> ' + str(v[1]) + '\n')

  
    def aktualisiereGotoCode(self):
        self.textProgramm.delete('1.0', END)
        p = self.interpreterGoto.getProgramm()
        pc = self.interpreterGoto.getPC()
        for i in range(len(p)):
            befehl = p[i]
            if i != pc:
                self.textProgramm.insert(END, "" + str(befehl[0]) + ' ' + str(befehl[1]) + '\n')
            else:
                self.textProgramm.insert(END, "> " + str(befehl[0]) + ' ' + str(befehl[1]) + '\n')

    def aktualisiereBonsaiCode(self):
        self.textBonsaiCode.delete('1.0', END)
        self.textBonsaiCode.insert(END, self.assembler.getBonsaiText())        


    def buttonInitialisierenClick(self):
        self.variablenzustand.initVariablen()
        self.aktualisiereVariablenzustand()


    def Button_Quelltext_Uebernehmen_Click(self):
        quelltext = self.quelltext.get('1.0', END)
        self.assembler.parse(quelltext)
        self.interpreterGoto.initProgramm(assembler.getProgramm())
        self.aktualisiereVariablenzustand()
        self.aktualisiereGotoCode()

        
        
        

    def Button_QuelltextLaden_Click(self):
        self.datei = tkinter.filedialog.askopenfile()
        self.quelltext.delete(1.0, END)
        if self.datei:
            self.quelltext.insert(1.0, self.datei.read())
            self.datei.close()

    def Button_QuelltextSpeichern_Click(self):
        self.datei = tkinter.filedialog.asksaveasfile()
        if self.datei:
            self.datei.write(self.quelltext.get(1.0, END) )
            self.datei.close()




        

    def Button_AnweisungAusfuehren_Click(self):
        self.interpreterGoto.anweisungAusfuehren()
        self.aktualisiereVariablenzustand()
        self.aktualisiereGotoCode()

    def Button_ProgrammAusfuehren_Click(self):
        self.interpreterGoto.programmAusfuehren()
        self.aktualisiereVariablenzustand()
        self.aktualisiereGotoCode()

    def Button_BonsaiSpeichern_Click(self):
        self.datei = tkinter.filedialog.asksaveasfile()
        if self.datei:
            self.datei.write(self.assembler.getBonsaiText())
            self.datei.close()
        
    def Button_BonsaiCodeErzeugen_Click(self):
        self.assembler.erzeugeBonsaiCode()
        self.assembler.erzeugeBonsaiText()
        self.aktualisiereBonsaiCode()


#-------------------------------------------------------------




from interpreter import *
from variablenzustand import *
from assembler import *



# Erzeugung des GUI-Objekts

variablenzustand = Variablenzustand()
assembler = Assembler(variablenzustand)
interpreterGoto = Interpreter(variablenzustand)

whileGUI = WhileGUI(variablenzustand, assembler, interpreterGoto)
whileGUI.fenster.mainloop()
